/*
 * Copyright (C) 2023 Spacemit Limited
 * All Rights Reserved.
 */
#ifndef _GC5035_SPM_SETTING_H_
#define _GC5035_SPM_SETTING_H_

#include "cam_sensors_module.h"

#ifdef __cplusplus
extern "C" {
#endif /* extern "C" */

struct regval_tab gc5035_spm_2592x1944_10bit_30fps_tab[] = {
    // window_size=2592*1944,mipi 2lane
    // mclk=24mhz,pclk=175.2Mhz,row_time=16.66us,mipi_data_rate=876Mbps
    // linelength=2920,framelength=2008
    // max_framerate=30fps
    /*SYSTEM*/
    {0xfc, 0x01},
    {0xf4, 0x40},
    {0xf5, 0xe9},
    {0xf6, 0x14},
#if 0
    //mclk=24mhz,pclk=175.2Mhz,row_time=16.66us,mipi_data_rate=876Mbps
    {0xf8,0x49},
#else
    // mclk=23.63mhz,pclk=189.04Mhz,row_time=15.446us,mipi_data_rate=945.2Mbps
    {0xf8, 0x50},
#endif
    {0xf9, 0x82},
    {0xfa, 0x00},
    {0xfc, 0x81},
    {0xfe, 0x00},
    {0x36, 0x01},
    {0xd3, 0x87},
    {0x36, 0x00},
    {0x33, 0x00},
    {0xfe, 0x03},
    {0x01, 0xe7},
    {0xf7, 0x01},
    {0xfc, 0x8f},
    {0xfc, 0x8f},
    {0xfc, 0x8e},
    {0xfe, 0x00},
    {0xee, 0x30},
    {0x87, 0x18},
    {0xfe, 0x01},
    {0x8c, 0x90},
    {0xfe, 0x00},
    /*Analog & CISCTL*/
    {0x03, 0x07},
    {0x04, 0xc8},
#if 0
    //mclk=24mhz, linelength=2920,framelength=2008
    {0x41,0x07},
    {0x42,0xd8},
#else
    // mclk=23.63mhz, linelength=2920,framelength=2158
    {0x41, 0x08},
    {0x42, 0x6e},
#endif
    {0x05, 0x02},
    {0x06, 0xda},
    {0x9d, 0x0c},
    {0x09, 0x00},
    {0x0a, 0x04},
    {0x0b, 0x00},
    {0x0c, 0x03},
    {0x0d, 0x07},
    {0x0e, 0xa8},  // 1960
    {0x0f, 0x0a},
    {0x10, 0x30},  // 2608
    {0x11, 0x02},
    {0x17, 0x80},
    {0x19, 0x05},
    {0xfe, 0x02},
    {0x30, 0x03},
    {0x31, 0x03},
    {0xfe, 0x00},
    {0xd9, 0xc0},
    {0x1b, 0x20},
    {0x21, 0x48},
    {0x28, 0x22},
    {0x29, 0x58},
    {0x44, 0x20},
    {0x4b, 0x10},
    {0x4e, 0x1a},
    {0x50, 0x11},
    {0x52, 0x33},
    {0x53, 0x44},
    {0x55, 0x10},
    {0x5b, 0x11},
    {0xc5, 0x02},
    {0x8c, 0x1a},
    {0xfe, 0x02},
    {0x33, 0x05},
    {0x32, 0x38},
    {0xfe, 0x00},
    {0x91, 0x80},
    {0x92, 0x28},
    {0x93, 0x20},
    {0x95, 0xa0},
    {0x96, 0xe0},
    {0xd5, 0xfc},
    {0x97, 0x28},
    {0x16, 0x0c},
    {0x1a, 0x1a},
    {0x1f, 0x11},
    {0x20, 0x10},
    {0x46, 0x83},
    {0x4a, 0x04},
    {0x54, 0x02},
    {0x62, 0x00},
    {0x72, 0x8f},
    {0x73, 0x89},
    {0x7a, 0x05},
    {0x7d, 0xcc},
    {0x90, 0x00},
    {0xce, 0x18},
    {0xd0, 0xb2},
    {0xd2, 0x40},
    {0xe6, 0xe0},
    {0xfe, 0x02},
    {0x12, 0x01},
    {0x13, 0x01},
    {0x14, 0x01},
    {0x15, 0x02},
    {0x22, 0x7c},
    {0xfe, 0x00},
    {0xfc, 0x88},
    {0xfe, 0x10},
    {0xfe, 0x00},
    {0xfc, 0x8e},
    {0xfe, 0x00},
    {0xfe, 0x00},
    {0xfe, 0x00},
    {0xfc, 0x88},
    {0xfe, 0x10},
    {0xfe, 0x00},
    {0xfc, 0x8e},
    /*GAIN*/
    {0xfe, 0x00},
    {0xb0, 0x6e},
    {0xb1, 0x01},
    {0xb2, 0x00},
    {0xb3, 0x00},
    {0xb4, 0x00},
    {0xb6, 0x00},
    {/*ISP*/},
    {0xfe, 0x01},
    {0x53, 0x00},
    {0x89, 0x03},
    {0x60, 0x40},
    /*BLK*/
    {0xfe, 0x01},
    {0x42, 0x21},
    {0x49, 0x03},
    {0x4a, 0xff},
    {0x4b, 0xc0},
    {0x55, 0x00},
    /*anti_blooming*/
    {0xfe, 0x01},
    {0x41, 0x28},
    {0x4c, 0x00},
    {0x4d, 0x00},
    {0x4e, 0x3c},
    {0x44, 0x08},
    {0x48, 0x02},
    /*CROP*/
    {0xfe, 0x01},
    {0x91, 0x00},
    {0x92, 0x02},  // 0x01
    {0x93, 0x00},
    {0x94, 0x07},
    {0x95, 0x07},  // 1944
    {0x96, 0x98},
    {0x97, 0x0a},  // 2592
    {0x98, 0x20},
    {0x99, 0x00},
    /*MIPI*/
    {0xfe, 0x03},
    {0x02, 0x57},
    {0x03, 0xb7},
    {0x15, 0x14},
    {0x18, 0x0f},
    {0x21, 0x22},
    {0x22, 0x06},
    {0x23, 0x48},
    {0x24, 0x12},
    {0x25, 0x28},
    {0x26, 0x08},
    {0x29, 0x06},
    {0x2a, 0x58},
    {0x2b, 0x08},
    {0xfe, 0x01},
    {0x8c, 0x10},
    {0xfe, 0x00},
    {0x3e, 0x01},  // stream off
};

#ifdef __cplusplus
}
#endif /* extern "C" */

#endif
