/*
 * Copyright (C) 2023 Spacemit Limited
 * All Rights Reserved.
 */
#ifndef _OV08D10_SPM_SETTING_H_
#define _OV08D10_SPM_SETTING_H_

#include "cam_sensors_module.h"

#ifdef __cplusplus
extern "C" {
#endif /* extern "C" */

struct regval_tab ov08d10_spm_3264x2448_10bit_30fps_tab[] = {
    //@@OV08D_MIPI_3264x2448_2lane_1440M_30fps_V2.0
    // 100 99 3264 2448
    //----------------------------------------------
    // MCLK: 24Mhz
    // resolution: 3264x2448
    // Mipi : 2 lane
    // Mipi data rate: 1440Mbps/Lane
    // SystemCLK   :36Mhz
    // FPS		: 30.008fps
    // HTS		:460
    // VTS		:2608
    // Tline	:12.778us
    // mirror/flip normal
    //---------------------------------------------
    {0xfd, 0x00},
    {0x20, 0x0e},  // sl 3 3
    {0x20, 0x0b},
    {0xfd, 0x00},
    {0x11, 0x2a},
#if 0  // MCLK = 24M
    {0x14, 0x43},
    {0x1b, 0xf0},
#else  // MCLK = 23.63M
    {0x14, 0x44},  // dpll_nc_sel[7:0]
    {0x18, 0x7a},  // pll3_nc_sel[7:0], def = 0x78
    {0x1b, 0xf4},  // mpll_nc_sel[7:0]
#endif
    {0x1e, 0x23},
    {0x16, 0x82},
    {0x21, 0x00},
    {0xfd, 0x01},
    {0x12, 0x00},
    {0x02, 0x00},  // exp 30ms
    {0x03, 0x12},
    {0x04, 0x50},
    {0x05, 0x00},
    {0x06, 0xd0},  // vblk
    {0x07, 0x05},
    {0x21, 0x02},
    {0x24, 0x30},  // AG 3x
    {0x33, 0x03},
    {0x01, 0x03},
    {0x19, 0x10},
    {0x42, 0x55},
    {0x43, 0x00},
    {0x47, 0x07},
    {0x48, 0x08},
    {0x4c, 0x38},
    {0xb2, 0x7e},
    {0xb3, 0x7b},
    {0xbd, 0x08},
    {0xd2, 0x47},  // 20210929 modify from 57 to 47
    {0xd3, 0x10},
    {0xd4, 0x0d},  // 20210929 modify from 08 to 0d
    {0xd5, 0x08},
    {0xd6, 0x07},
    {0xb1, 0x00},
    {0xb4, 0x00},
    {0xb7, 0x0a},
    {0xbc, 0x44},
    {0xbf, 0x42},
    {0xc1, 0x10},
    {0xc3, 0x24},
    {0xc8, 0x03},
    {0xc9, 0xf8},
    {0xe1, 0x33},
    {0xe2, 0xbb},
    {0x51, 0x0c},
    {0x52, 0x0a},
    {0x57, 0x8c},
    {0x59, 0x09},
    {0x5a, 0x08},
    {0x5e, 0x10},
    {0x60, 0x02},
    {0x6d, 0x5c},
    {0x76, 0x16},
    {0x7c, 0x11},
    {0x90, 0x28},
    {0x91, 0x16},
    {0x92, 0x1c},
    {0x93, 0x24},
    {0x95, 0x48},
    {0x9c, 0x06},
    {0xca, 0x0c},
    {0xce, 0x0d},
    {0xfd, 0x01},
    {0xc0, 0x00},
    {0xdd, 0x18},
    {0xde, 0x19},
    {0xdf, 0x32},
    {0xe0, 0x70},
    {0xfd, 0x01},
    {0xc2, 0x05},
    {0xd7, 0x88},
    {0xd8, 0x77},
    {0xd9, 0x66},
    {0xfd, 0x07},
    {0x00, 0xf8},  // blc config
    {0x01, 0x2b},
    {0x05, 0x40},  // blc target 0x40
    {0x08, 0x06},
    {0x09, 0x11},
    {0x28, 0x6f},
    {0x2a, 0x20},
    {0x2b, 0x05},
    {0x5e, 0x10},
    {0x52, 0x00},
    {0x53, 0x80},
    {0x54, 0x00},
    {0x55, 0x80},
    {0x56, 0x00},
    {0x57, 0x80},
    {0x58, 0x00},
    {0x59, 0x80},
    {0x5c, 0x3f},
    {0xfd, 0x02},  // dpc control
    {0x9a, 0x30},  // dpcon bit[5],otpdpc// bit[4],dynamic dpc
    {0xa8, 0x02},
    {0xfd, 0x02},
    {0xa0, 0x00},  // dig crop
    {0xa1, 0x08},
    {0xa2, 0x09},
    {0xa3, 0x90},
    {0xa4, 0x00},
    {0xa5, 0x08},
    {0xa6, 0x0c},
    {0xa7, 0xc0},
    // For Full size OTP_DPC mirror off/flip off
    {0xfd, 0x05},
    {0x04, 0x40},
    {0x07, 0x00},
    {0x0D, 0x01},
    {0x0F, 0x01},
    {0x10, 0x00},
    {0x11, 0x00},
    {0x12, 0x0C},
    {0x13, 0xCF},
    {0x14, 0x00},
    {0x15, 0x00},
    {0x18, 0x00},
    {0x19, 0x00},
    {0xfd, 0x00},
    {0x24, 0x01},
    {0xc0, 0x16},
    {0xc1, 0x08},
    {0xc2, 0x30},
    {0x8e, 0x0c},  // mipi output: H-SIZE
    {0x8f, 0xc0},
    {0x90, 0x09},  // V-SIZE
    {0x91, 0x90},
    {0xb7, 0x02},
    {0xfd, 0x00},  // must locate this group reg. at the end
    {0x20, 0x0f},  // soft reset
    {0xe7, 0x03},
    {0xe7, 0x00},
    {0xfd, 0x01},
    {0xfd, 0x00},
    {0xa0, 0x00},  // bit[0]:mipi en
};

struct regval_tab ov08d10_spm_1632x1224_10bit_30fps_tab[] = {
    // OV08D_MIPI_1632x1224_2lane_720M_30fps_V2.0
    //----------------------------------------------
    // MCLK: 24Mhz
    // resolution: 1632x1224
    // Mipi : 2 lane
    // Mipi data rate: 720Mbps/Lane
    // SystemCLK   :36Mhz
    // FPS			: 30.02fps
    // HTS		:478
    // VTS		:2508
    // Tline 	:13.2778us
    // mirror/flip normal
    //---------------------------------------------
    {0xfd, 0x00},
    {0x20, 0x0e},
    {0x20, 0x0b},
    {0xfd, 0x00},
    {0x1d, 0x00},
    {0x18, 0x3c},
    {0x1c, 0x19},
    {0x11, 0x2a},
    {0x14, 0x43},
    {0x1e, 0x23},
    {0x16, 0x82},
    {0x21, 0x00},
    {0xfd, 0x01},
    {0x1a, 0x0a},
    {0x1b, 0x08},
    {0x2a, 0x01},
    {0x2b, 0x9a},
    {0xfd, 0x01},
    {0x12, 0x00},
    {0x02, 0x00},  // exp 16ms
    {0x03, 0x09},
    {0x04, 0x6a},
#if 0  // MCLK = 24M; Tline :13.2778us; VTS :2508
    {0x05, 0x09},  // vblk
    {0x06, 0xd0},
#else
    // MCLK = 23.63M; Tline :13.4857us; VTS :2470
    {0x05, 0x09},  // vblk
    {0x06, 0x84},
#endif
    {0x07, 0x05},
    {0x21, 0x02},
    {0x24, 0xf8},  // AG15.5x
    {0x31, 0x06},
    {0x33, 0x03},
    {0x01, 0x03},
    {0x19, 0x10},
    {0x42, 0x55},
    {0x43, 0x00},
    {0x47, 0x07},
    {0x48, 0x08},
    {0x4c, 0x38},
    {0xb2, 0x7e},
    {0xb3, 0x7b},
    {0xbd, 0x08},
    {0xd2, 0x47},  // 20210929 modify from 57 to 47
    {0xd3, 0x10},
    {0xd4, 0x0d},  // 20210929 modify from 08 to 0d
    {0xd5, 0x08},
    {0xd6, 0x07},
    {0xb1, 0x00},
    {0xb4, 0x00},
    {0xb7, 0x0a},
    {0xbc, 0x44},
    {0xbf, 0x42},
    {0xc1, 0x10},
    {0xc3, 0x24},
    {0xc8, 0x03},
    {0xc9, 0xf8},
    {0xe1, 0x33},
    {0xe2, 0xbb},
    {0x51, 0x0c},
    {0x52, 0x0a},
    {0x57, 0x8c},
    {0x59, 0x09},
    {0x5a, 0x08},
    {0x5e, 0x10},
    {0x60, 0x02},
    {0x6d, 0x5c},
    {0x76, 0x16},
    {0x7c, 0x1a},
    {0x90, 0x28},
    {0x91, 0x16},
    {0x92, 0x1c},
    {0x93, 0x24},
    {0x95, 0x48},
    {0x9c, 0x06},
    {0xca, 0x0c},
    {0xce, 0x0d},
    {0xfd, 0x01},
    {0xc0, 0x00},
    {0xdd, 0x18},
    {0xde, 0x19},
    {0xdf, 0x32},
    {0xe0, 0x70},
    {0xfd, 0x01},
    {0xc2, 0x05},
    {0xd7, 0x88},
    {0xd8, 0x77},
    {0xd9, 0x66},
    {0xfd, 0x07},
    {0x00, 0xf8},
    {0x01, 0x2b},
    {0x05, 0x40},
    {0x08, 0x03},
    {0x09, 0x08},
    {0x28, 0x6f},
    {0x2a, 0x20},
    {0x2b, 0x05},
    {0x2c, 0x01},
    {0x50, 0x02},
    {0x51, 0x03},
    {0x5e, 0x10},
    {0x52, 0x00},
    {0x53, 0x80},
    {0x54, 0x00},
    {0x55, 0x80},
    {0x56, 0x00},
    {0x57, 0x80},
    {0x58, 0x00},
    {0x59, 0x80},
    {0x5c, 0x3f},
    {0xfd, 0x02},
    {0x9a, 0x30},  // dpcon
    {0xa8, 0x02},
    {0xfd, 0x02},
    {0xa9, 0x04},  // dpc size
    {0xaa, 0xd0},
    {0xab, 0x06},
    {0xac, 0x68},
    {0xfd, 0x02},
    {0xa0, 0x00},
    {0xa1, 0x04},
    {0xa2, 0x04},
    {0xa3, 0xc8},
    {0xa4, 0x00},
    {0xa5, 0x04},
    {0xa6, 0x06},
    {0xa7, 0x60},
    {0xfd, 0x05},  // For Bin size OTP_DPC mirror off/flip off
    {0x04, 0x60},
    {0x06, 0x80},
    {0x07, 0x99},
    {0x0D, 0x03},
    {0x0F, 0x03},
    {0x10, 0x00},
    {0x11, 0x00},
    {0x12, 0x0C},
    {0x13, 0xCF},
    {0x14, 0x00},
    {0x15, 0x00},
    {0x18, 0x06},
    {0x19, 0x68},
    {0xfd, 0x00},
    {0x24, 0x01},
    {0xc0, 0x16},
    {0xc1, 0x08},
    {0xc2, 0x30},
    {0x8e, 0x06},  // mipi output
    {0x8f, 0x60},
    {0x90, 0x04},
    {0x91, 0xc8},
    {0x93, 0x0e},
    {0x94, 0x77},
    {0x95, 0x77},
    {0x96, 0x10},
    {0x98, 0x88},
    {0x9c, 0x1a},
    {0xb7, 0x02},
    {0xfd, 0x00},  // must locate this group reg. at the end
    {0x20, 0x0f},  // soft reset
    {0xe7, 0x03},
    {0xe7, 0x00},
    {0xfd, 0x01},
    {0xfd, 0x00},
    {0xa0, 0x00},  // mipi stream off; bit[0]:mipi en
};

struct regval_tab ov08d10_spm_1920x1080_10bit_30fps_tab[] = {
    // OV08D_MIPI_1920x1080_2lane_882M_30fps_V2.0
    //----------------------------------------------
    // MCLK: 24Mhz
    // resolution: 1920x1080
    // Mipi : 2 lane
    // Mipi data rate: 882Mbps/Lane
    // SystemCLK   :36Mhz
    // FPS			: 30.02fps
    // HTS		:516
    // VTS		:2324
    // Tline 	:14.33us
    // mirror/flip normal
    //---------------------------------------------
    {0xfd, 0x00},
    {0x20, 0x0e},
    {0x20, 0x0b},
    {0xfd, 0x00},
    {0x11, 0x2a},
    {0x14, 0x43},
    {0x1e, 0x23},
    {0x16, 0x82},
    {0x1b, 0x93},
    {0x21, 0x00},
    {0xfd, 0x01},
    {0x12, 0x00},
    {0x02, 0x00},  // exp 16ms
    {0x03, 0x08},
    {0x04, 0xb9},
#if 0  // MCLK = 24M; Tline :14.33us; VTS :2324
    {0x05, 0x09},
    {0x06, 0x08},  // vblk
#else  // MCLK = 23.63M; Tline :14.55438us; VTS :2290
    {0x05, 0x08},  // vblk
    {0x06, 0xC4},
#endif
    {0x07, 0x05},
    {0x21, 0x02},
    {0x24, 0x40},
    {0x31, 0x01},  // ana crop
    {0x28, 0x00},
    {0x29, 0xa9},
    {0x2a, 0x01},
    {0x2b, 0xe2},
    {0x2c, 0x02},
    {0x2d, 0x9c},
    {0x2e, 0x04},
    {0x2f, 0x40},
    {0x33, 0x03},
    {0x01, 0x03},
    {0x19, 0x10},
    {0x42, 0x55},
    {0x43, 0x00},
    {0x47, 0x07},
    {0x48, 0x08},
    {0x4c, 0x38},
    {0xb2, 0x7e},
    {0xb3, 0x7b},
    {0xbd, 0x08},
    {0xd2, 0x47},  // 20210929 modify from 57 to 47
    {0xd3, 0x10},
    {0xd4, 0x0d},  // 20210929 modify from 08 to 0d
    {0xd5, 0x08},
    {0xd6, 0x07},
    {0xb1, 0x00},
    {0xb4, 0x00},
    {0xb7, 0x0a},
    {0xbc, 0x44},
    {0xbf, 0x42},
    {0xc1, 0x10},
    {0xc3, 0x24},
    {0xc8, 0x03},
    {0xc9, 0xf8},
    {0xe1, 0x33},
    {0xe2, 0xbb},
    {0x51, 0x0c},
    {0x52, 0x0a},
    {0x57, 0x8c},
    {0x59, 0x09},
    {0x5a, 0x08},
    {0x5e, 0x10},
    {0x60, 0x02},
    {0x6d, 0x5c},
    {0x76, 0x16},
    {0x7c, 0x2d},
    {0x90, 0x28},
    {0x91, 0x16},
    {0x92, 0x1c},
    {0x93, 0x24},
    {0x95, 0x48},
    {0x9c, 0x06},
    {0xca, 0x0c},
    {0xce, 0x0d},
    {0xfd, 0x01},
    {0xc0, 0x00},
    {0xdd, 0x18},
    {0xde, 0x19},
    {0xdf, 0x32},
    {0xe0, 0x70},
    {0xfd, 0x01},
    {0xc2, 0x05},
    {0xd7, 0x88},
    {0xd8, 0x77},
    {0xd9, 0x66},
    {0xfd, 0x07},
    {0x00, 0xf8},  // blc config
    {0x01, 0x2b},
    {0x05, 0x40},  // blc target 0x40
    {0x08, 0x06},
    {0x09, 0x11},
    {0x28, 0x6f},
    {0x2a, 0x20},
    {0x2b, 0x05},
    {0x5e, 0x10},
    {0x52, 0x00},
    {0x53, 0x80},
    {0x54, 0x00},
    {0x55, 0x80},
    {0x56, 0x00},
    {0x57, 0x80},
    {0x58, 0x00},
    {0x59, 0x80},
    {0x5c, 0x3f},
    {0xfd, 0x02},
    {0x9a, 0x30},  // dpc on
    {0xa8, 0x02},
    {0xa9, 0x04},
    {0xaa, 0x40},
    {0xab, 0x07},
    {0xac, 0x88},
    {0xfd, 0x02},  // digit crop size
    {0xa0, 0x00},
    {0xa1, 0x04},
    {0xa2, 0x04},
    {0xa3, 0x38},
    {0xa4, 0x00},
    {0xa5, 0x04},
    {0xa6, 0x07},
    {0xa7, 0x80},
    {0xfd, 0x05},  // For Full size OTP_DPC mirror off/flip off
    {0x04, 0x40},
    {0x06, 0x80},
    {0x07, 0x00},
    {0x0D, 0x01},
    {0x0F, 0x01},
    {0x10, 0x02},
    {0x11, 0xA4},
    {0x12, 0x0A},
    {0x13, 0x2b},
    {0x14, 0x02},
    {0x15, 0xb0},
    {0x18, 0x07},
    {0x19, 0x88},
    {0xfd, 0x00},
    {0x24, 0x01},
    {0xc0, 0x16},
    {0xc1, 0x08},
    {0xc2, 0x30},
    {0x8e, 0x07},
    {0x8f, 0x80},
    {0x90, 0x04},
    {0x91, 0x38},
    {0xb7, 0x02},
    {0xfd, 0x00},  // must locate this group reg. at the end
    {0x20, 0x0f},  // soft reset
    {0xe7, 0x03},
    {0xe7, 0x00},
    {0xfd, 0x01},
    {0xfd, 0x00},
    {0xa0, 0x00},  // mipi stream off; bit[0]:mipi en
};

struct regval_tab ov08d10_spm_640x480_10bit_30fps_tab[] = {
    // OV08D_MIPI_1632x1224_1lane_720M_30fps_V2.0
    //----------------------------------------------
    // MCLK: 24Mhz
    // resolution: 1632x1224
    // Mipi : 1 lane
    // Mipi data rate: 720Mbps/Lane
    // SystemCLK   :18Mhz
    // FPS			: 30.02fps
    // HTS		:478
    // VTS		:1252
    // Tline 	:26.5556us
    // mirror/flip normal
    //---------------------------------------------
    {0xfd, 0x00},
    {0x20, 0x0e},
    {0x20, 0x0b},
    //OV08D_PLL_setting
    {0x10, 0x05},
    {0x11, 0x2a},
    {0x12, 0x03},
    {0x13, 0x07},
    {0x14, 0x43},
    {0x15, 0x02},
    {0x16, 0x82},
    {0x17, 0x45},
    {0x18, 0x3c},
    {0x19, 0x04},
    {0x1a, 0x05},
    {0x1b, 0xf0},
    {0x1c, 0x19},
    {0x1d, 0x00},
    {0x1e, 0x23},
    {0x1f, 0x0f},
    {0x20, 0x0f},
    {0x21, 0x00},
    //OV08D_PLL_setting_end
    {0xfd, 0x01},
    {0x1a, 0x0a},
    {0x1b, 0x08},
    {0x2a, 0x01},
    {0x2b, 0x9a},
    {0xfd, 0x01},
    {0x12, 0x00},
    {0x02, 0x00},  // exp 16ms
    {0x03, 0x01},
    {0x04, 0x6a},
#if 1  // MCLK = 24M; hts=0x1de =478,vts=0x4e4=1252
    {0x05, 0x00},  // vblk
    {0x06, 0x00},
#else
    // MCLK = 23.63M; Tline :13.4857us; VTS :2470
    {0x05, 0x09},  // vblk
    {0x06, 0x84},
#endif
    {0x07, 0x05},
    {0x21, 0x02},
    {0x24, 0xf8},  // AG15.5x
    {0x31, 0x06},
    {0x33, 0x03},
    {0x01, 0x03},
    {0x19, 0x10},
    {0x42, 0x55},
    {0x43, 0x00},
    {0x47, 0x07},
    {0x48, 0x08},
    {0x4c, 0x38},
    {0xb2, 0x7e},
    {0xb3, 0x7b},
    {0xbd, 0x08},
    {0xd2, 0x47},  // 20210929 modify from 57 to 47
    {0xd3, 0x10},
    {0xd4, 0x0d},  // 20210929 modify from 08 to 0d
    {0xd5, 0x08},
    {0xd6, 0x07},
    {0xb1, 0x00},
    {0xb4, 0x00},
    {0xb7, 0x0a},
    {0xbc, 0x44},
    {0xbf, 0x42},
    {0xc1, 0x10},
    {0xc3, 0x24},
    {0xc8, 0x03},
    {0xc9, 0xf8},
    {0xe1, 0x33},
    {0xe2, 0xbb},
    {0x51, 0x0c},
    {0x52, 0x0a},
    {0x57, 0x8c},
    {0x59, 0x09},
    {0x5a, 0x08},
    {0x5e, 0x10},
    {0x60, 0x02},
    {0x6d, 0x5c},
    {0x76, 0x16},
    {0x7c, 0x1a},
    {0x90, 0x28},
    {0x91, 0x16},
    {0x92, 0x1c},
    {0x93, 0x24},
    {0x95, 0x48},
    {0x9c, 0x06},
    {0xca, 0x0c},
    {0xce, 0x0d},
    {0xfd, 0x01},
    {0xc0, 0x00},
    {0xdd, 0x18},
    {0xde, 0x19},
    {0xdf, 0x32},
    {0xe0, 0x70},
    {0xfd, 0x01},
    {0xc2, 0x05},
    {0xd7, 0x88},
    {0xd8, 0x77},
    {0xd9, 0x66},
    {0xfd, 0x07},
    {0x00, 0xf8},
    {0x01, 0x2b},
    {0x05, 0x40},
    {0x08, 0x03},
    {0x09, 0x08},
    {0x28, 0x6f},
    {0x2a, 0x20},
    {0x2b, 0x05},
    {0x2c, 0x01},
    {0x50, 0x02},
    {0x51, 0x03},
    {0x5e, 0x10},
    {0x52, 0x00},
    {0x53, 0x80},
    {0x54, 0x00},
    {0x55, 0x80},
    {0x56, 0x00},
    {0x57, 0x80},
    {0x58, 0x00},
    {0x59, 0x80},
    {0x5c, 0x3f},
    {0xfd, 0x02},
    {0x9a, 0x30},  // dpcon
    {0xa8, 0x02},
    {0xfd, 0x02},
    {0xa9, 0x04},  // dpc size
    {0xaa, 0xd0},
    {0xab, 0x06},
    {0xac, 0x68},
    {0xfd, 0x02},
#if 0 //1632x1224
    {0xa0, 0x00},
    {0xa1, 0x04},
    {0xa2, 0x04},
    {0xa3, 0xc8},
    {0xa4, 0x00},
    {0xa5, 0x04},
    {0xa6, 0x06},
    {0xa7, 0x60},
#else //640x480
    {0xa0, 0x00},
    {0xa1, 0x04},
    {0xa2, 0x01},
    {0xa3, 0xe0},
    {0xa4, 0x00},
    {0xa5, 0x04},
    {0xa6, 0x02},
    {0xa7, 0x80},
#endif
    {0xfd, 0x05},  // For Bin size OTP_DPC mirror off/flip off
    {0x04, 0x60},
    {0x06, 0x80},
    {0x07, 0x99},
    {0x0D, 0x03},
    {0x0F, 0x03},
    {0x10, 0x00},
    {0x11, 0x00},
    {0x12, 0x0C},
    {0x13, 0xCF},
    {0x14, 0x00},
    {0x15, 0x00},
    {0x18, 0x06},
    {0x19, 0x68},
    {0xfd, 0x00},
    {0x24, 0x01},
    {0xc0, 0x16},
    {0xc1, 0x08},
    {0xc2, 0x30},
#if 0 //1632x1224
    {0x8e, 0x06},  // mipi output
    {0x8f, 0x60},
    {0x90, 0x04},
    {0x91, 0xc8},
#else //640x480
    {0x8e, 0x02},  // mipi output
    {0x8f, 0x80},
    {0x90, 0x01},
    {0x91, 0xe0},
#endif
    {0x93, 0x0e},
    {0x94, 0x77},
    {0x95, 0x77},
    {0x96, 0x10},
    {0x98, 0x88},
    {0x9c, 0x1a},
    {0xb6, 0x00},  //mipi 1 lane
    {0xb7, 0x02},
    {0xbe, 0x11},  //disable mipi lane1
    {0xfd, 0x00},  // must locate this group reg. at the end
    {0x20, 0x0f},  // soft reset
    {0xe7, 0x03},
    {0xe7, 0x00},
    {0xa0, 0x00},  // mipi stream off; bit[0]:mipi en
};

#ifdef __cplusplus
}
#endif /* extern "C" */

#endif
